<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/htot.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>htot.c</h1><a href="htot_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: htot.c 2966 2010-02-08 23:31:15Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#endif</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="preprocessor">#include &quot;spintorq/spintorq.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#endif</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="keyword">static</span> <span class="keywordtype">int</span> doinit=1;
<a name="l00038"></a>00038 <span class="keyword">static</span> Vec VHtotsum=PETSC_NULL;
<a name="l00039"></a>00039 <span class="keyword">static</span> Vec VMom; 
<a name="l00041"></a><a class="code" href="htot_8c.html#a85ee39fe66d72226d10cb331fda60cd1">00041</a> <span class="keywordtype">int</span> <a class="code" href="htot_8c.html#a85ee39fe66d72226d10cb331fda60cd1">Htot_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Htot on\n&quot;</span>);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>);CHKERRQ(ierr);
<a name="l00048"></a>00048   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;VMom);CHKERRQ(ierr);
<a name="l00049"></a>00049   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;VHtotsum);CHKERRQ(ierr);
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="htot_8c.html#ab9d30ce64708afeca163280386deb654">00055</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#ab9d30ce64708afeca163280386deb654">Htot</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">/* initialize if necessary */</span>
<a name="l00060"></a>00060   <span class="keywordflow">if</span> (doinit) {
<a name="l00061"></a>00061     ierr = <a class="code" href="htot_8c.html#a85ee39fe66d72226d10cb331fda60cd1">Htot_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00062"></a>00062     doinit=0;
<a name="l00063"></a>00063   }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   ierr = VecZeroEntries(VHtotsum);CHKERRQ(ierr);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   ierr = <a class="code" href="field_8h.html#ace2ad4bc212a40902a58d3bfdaa0518a">Hcubic</a>(gdata,VHtotsum);CHKERRQ(ierr);
<a name="l00068"></a>00068   ierr = <a class="code" href="field_8h.html#a8e779a08a066fda9160df1a7e5102a58">Hdemag</a>(gdata,VHtotsum);CHKERRQ(ierr);
<a name="l00069"></a>00069   ierr = <a class="code" href="field_8h.html#a97e3d5671797656fb91afa5e61778e74">Helastic</a>(gdata,VHtotsum);CHKERRQ(ierr);
<a name="l00070"></a>00070   ierr = <a class="code" href="field_8h.html#ab3c152ad4a30f46fd55fff971a53d2ae">Hexchani</a>(gdata,VHtotsum);CHKERRQ(ierr);
<a name="l00071"></a>00071   ierr = <a class="code" href="field_8h.html#aeaf153862ea87b88e30bee559bf1d481">Hexternal</a>(gdata,VHtotsum);CHKERRQ(ierr);
<a name="l00072"></a>00072 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>  ierr = HIlayerExch(gdata,VHtotsum);CHKERRQ(ierr);
<a name="l00074"></a>00074   ierr = Hnonlin(gdata,VHtotsum);CHKERRQ(ierr);
<a name="l00075"></a>00075   ierr = Hcancel(gdata,VHtotsum);CHKERRQ(ierr);
<a name="l00076"></a>00076 <span class="preprocessor">#endif</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span><span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>  <span class="comment">/* initialize vectors to NULL */</span>
<a name="l00079"></a>00079   gdata-&gt;VHspintorque=PETSC_NULL;
<a name="l00080"></a>00080   gdata-&gt;VHspinforce=PETSC_NULL;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   ierr = Hspintorq(gdata);CHKERRQ(ierr);
<a name="l00083"></a>00083   ierr = Hspinforce(gdata);CHKERRQ(ierr);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keywordflow">if</span> (gdata-&gt;VHspintorque!=PETSC_NULL &amp;&amp; gdata-&gt;VHspinforce!=PETSC_NULL) {
<a name="l00086"></a>00086     SETERRQ(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;Spin torque and spin force are switched on at the same time!\n&quot;</span>);
<a name="l00087"></a>00087   }
<a name="l00088"></a>00088 <span class="preprocessor">#endif</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>
<a name="l00090"></a>00090   ierr = VecCopy(VHtotsum,gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>);CHKERRQ(ierr);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="htot_8c.html#a270a74fb6c65379e026cfb5c4de11443">00096</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a270a74fb6c65379e026cfb5c4de11443">Htot_Gradient</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00097"></a>00097 {
<a name="l00098"></a>00098   Vec VHtemp;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">/* abusing VMom */</span>
<a name="l00103"></a>00103   VHtemp=VMom;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="comment">/* initialize if necessary */</span>
<a name="l00106"></a>00106   <span class="keywordflow">if</span> (doinit) {
<a name="l00107"></a>00107     ierr = <a class="code" href="htot_8c.html#a85ee39fe66d72226d10cb331fda60cd1">Htot_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00108"></a>00108     doinit=0;
<a name="l00109"></a>00109   }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="preprocessor">#if 1</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>  <span class="comment">/* gives correct result for Etot in example mumag3: 1.240375e+05 ; LLG: 1.240388e+05 */</span>
<a name="l00113"></a>00113   <span class="comment">/* appears to converge faster for example fept, headfield_nonlin w/o demag (but higher Etot) ! */</span>
<a name="l00114"></a>00114   <span class="comment">/*</span>
<a name="l00115"></a>00115 <span class="comment">  m=M*Ms*V</span>
<a name="l00116"></a>00116 <span class="comment">  grad(E)=dE/dm=dE/d(M*Ms*V)</span>
<a name="l00117"></a>00117 <span class="comment">  H=-dE/dm</span>
<a name="l00118"></a>00118 <span class="comment">  grad(E)=-H</span>
<a name="l00119"></a>00119 <span class="comment"></span>
<a name="l00120"></a>00120 <span class="comment">  However, Ms and V are fixed and only M varies in our formulation:</span>
<a name="l00121"></a>00121 <span class="comment">  grad(E)=dE/dM=Ms*V*dE/d(M*Ms*V)=Ms*V*dE/dm=Ms*V*(-H)</span>
<a name="l00122"></a>00122 <span class="comment">  */</span>
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   ierr = <a class="code" href="field_8h.html#ab9d30ce64708afeca163280386deb654">Htot</a>(gdata);CHKERRQ(ierr);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">/* This scaling with gdata-&gt;VMs3 is necessary for big writer models to converge properly.</span>
<a name="l00127"></a>00127 <span class="comment">     Causes wiggles in M in headfield_nonlin while iterating, but converges fine.</span>
<a name="l00128"></a>00128 <span class="comment">  */</span>
<a name="l00129"></a>00129   ierr = VecPointwiseMult(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>);CHKERRQ(ierr);
<a name="l00130"></a>00130 <span class="preprocessor">#else</span>
<a name="l00131"></a>00131 <span class="preprocessor"></span>  <span class="comment">/* for comparison between hand-coded and TAO&#39;s finite difference gradient: magpar_examples5/cube_test_grad */</span>
<a name="l00132"></a>00132   <span class="comment">/* gives incorrect result for Etot in example mumag3: 1.256195e+05 (too high) */</span>
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   ierr = VecZeroEntries(VHtotsum);CHKERRQ(ierr);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="comment">/* calculate field/gradient contributions and apply fudge (?) factor */</span>
<a name="l00137"></a>00137   VecZeroEntries(VHtemp);<a class="code" href="field_8h.html#ace2ad4bc212a40902a58d3bfdaa0518a">Hcubic</a>(gdata,VHtemp);     VecAXPY(VHtotsum,1.0,VHtemp); <span class="comment">/* ok */</span>
<a name="l00138"></a>00138   VecZeroEntries(VHtemp);<a class="code" href="field_8h.html#a8e779a08a066fda9160df1a7e5102a58">Hdemag</a>(gdata,VHtemp);     VecAXPY(VHtotsum,0.5,VHtemp); <span class="comment">/* ok */</span>
<a name="l00139"></a>00139   VecZeroEntries(VHtemp);<a class="code" href="field_8h.html#a97e3d5671797656fb91afa5e61778e74">Helastic</a>(gdata,VHtemp);   VecAXPY(VHtotsum,2.0,VHtemp); <span class="comment">/* ok */</span>
<a name="l00140"></a>00140   VecZeroEntries(VHtemp);<a class="code" href="field_8h.html#ab3c152ad4a30f46fd55fff971a53d2ae">Hexchani</a>(gdata,VHtemp);   VecAXPY(VHtotsum,1.0,VHtemp); <span class="comment">/* ok */</span>
<a name="l00141"></a>00141   VecZeroEntries(VHtemp);<a class="code" href="field_8h.html#aeaf153862ea87b88e30bee559bf1d481">Hexternal</a>(gdata,VHtemp);  VecAXPY(VHtotsum,1.0,VHtemp); <span class="comment">/* ok */</span>
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00144"></a>00144 <span class="preprocessor"></span>  VecZeroEntries(VHtemp);HIlayerExch(gdata,VHtemp);VecAXPY(VHtotsum,1.0,VHtemp); <span class="comment">/* ok */</span>
<a name="l00145"></a>00145   VecZeroEntries(VHtemp);Hnonlin(gdata,VHtemp);    VecAXPY(VHtotsum,1.0,VHtemp); <span class="comment">/* ok */</span>
<a name="l00146"></a>00146   VecZeroEntries(VHtemp);Hcancel(gdata,VHtemp);    VecAXPY(VHtotsum,1.0,VHtemp); <span class="comment">/* TODO */</span>
<a name="l00147"></a>00147 <span class="preprocessor">#endif</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>
<a name="l00149"></a>00149   ierr = VecCopy(VHtotsum,gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>);CHKERRQ(ierr);
<a name="l00150"></a>00150   ierr = VecPointwiseMult(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>);CHKERRQ(ierr);
<a name="l00151"></a>00151 <span class="preprocessor">#endif</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>
<a name="l00153"></a>00153   ierr = VecScale(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,-1.0);CHKERRQ(ierr);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   PetscReal *ta_Htot;
<a name="l00156"></a>00156   VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,&amp;ta_Htot);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   <span class="comment">/* TODO: set up Vec and do VecPointwiseMult instead of the loop */</span>
<a name="l00159"></a>00159   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;i++) {
<a name="l00160"></a>00160     <span class="comment">/* skip non-magnetic vertices and vertices with alpha &gt;= RIGID_M_ALPHA */</span>
<a name="l00161"></a>00161     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]+4]&lt;=0.0 ||
<a name="l00162"></a>00162         gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]+9]&gt;=<a class="code" href="griddata_8h.html#a8a54558688c833b1f886703d3012f1dd">RIGID_M_ALPHA</a>) {
<a name="l00163"></a>00163       ta_Htot[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0]=0.0;
<a name="l00164"></a>00164       ta_Htot[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1]=0.0;
<a name="l00165"></a>00165       ta_Htot[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2]=0.0;
<a name="l00166"></a>00166       <span class="keywordflow">continue</span>;
<a name="l00167"></a>00167     }
<a name="l00168"></a>00168   }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,&amp;ta_Htot);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00173"></a>00173 }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a><a class="code" href="htot_8c.html#a8ad42d15c17241a1313243ebd0d0ab11">00176</a> <span class="keywordtype">int</span> <a class="code" href="htot_8c.html#a8ad42d15c17241a1313243ebd0d0ab11">CalcEnergy</a>(Vec M,<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00177"></a>00177 {
<a name="l00178"></a>00178   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="comment">/* calculate &quot;magnetic moments&quot; VMom on vertices */</span>
<a name="l00181"></a>00181   ierr = VecPointwiseMult(VMom,gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   PetscReal e,etot;
<a name="l00184"></a>00184   etot=0;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   ierr = <a class="code" href="field_8h.html#aea497be5e9a188c3f1627b6692951515">Hcubic_Energy</a>(gdata,M,&amp;e);     CHKERRQ(ierr);etot += e;gdata-&gt;<a class="code" href="structGridData.html#accc6d5863bfdcbf0dde4e412350729b1">Eexchani</a>  = e/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>; <span class="comment">/* part of anisotropy energy */</span>
<a name="l00187"></a>00187   ierr = <a class="code" href="field_8h.html#aed83146289258f6f29a808dc50853f65">Hdemag_Energy</a>(gdata,M,&amp;e);     CHKERRQ(ierr);etot += e;gdata-&gt;<a class="code" href="structGridData.html#a93b54f2f6a796c1528054e5b91977287">Edem</a>      = e/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>;
<a name="l00188"></a>00188   ierr = <a class="code" href="field_8h.html#a67380d67fc85c798265c8a83d73f5388">Helastic_Energy</a>(gdata,M,&amp;e);   CHKERRQ(ierr);etot += e;
<a name="l00189"></a>00189   ierr = <a class="code" href="field_8h.html#a733ba0411bb628270a030775416d902a">Hexchani_Energy</a>(gdata,M,&amp;e);   CHKERRQ(ierr);etot += e;gdata-&gt;<a class="code" href="structGridData.html#accc6d5863bfdcbf0dde4e412350729b1">Eexchani</a> += e/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>; <span class="comment">/* add to anisotropy+exchange energy */</span>
<a name="l00190"></a>00190 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span>  ierr = Hexchonly_Energy(gdata,M,&amp;e);  CHKERRQ(ierr);          gdata-&gt;Eexchonly = e/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>; <span class="comment">/* don&#39;t add to etot!!! */</span>
<a name="l00192"></a>00192 <span class="preprocessor">#endif</span>
<a name="l00193"></a>00193 <span class="preprocessor"></span>  ierr = <a class="code" href="field_8h.html#abab705ab0b3df8ea71709f470033aee2">Hexternal_Energy</a>(gdata,M,&amp;e);  CHKERRQ(ierr);etot += e;gdata-&gt;<a class="code" href="structGridData.html#a17b4a3f0a4fcf4832fe0004f242a4ecb">Eext</a>      = e/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>;
<a name="l00194"></a>00194 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span>  ierr = Hcancel_Energy(gdata,M,&amp;e);    CHKERRQ(ierr);etot += e;gdata-&gt;<a class="code" href="structGridData.html#a17b4a3f0a4fcf4832fe0004f242a4ecb">Eext</a>     += e/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>;
<a name="l00196"></a>00196   ierr = HIlayerExch_Energy(gdata,M,&amp;e);CHKERRQ(ierr);etot += e;gdata-&gt;<a class="code" href="structGridData.html#accc6d5863bfdcbf0dde4e412350729b1">Eexchani</a> += e/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>; <span class="comment">/* add to anisotropy+exchange energy */</span>
<a name="l00197"></a>00197   ierr = Hnonlin_Energy(gdata,M,&amp;e);    CHKERRQ(ierr);etot += e;gdata-&gt;<a class="code" href="structGridData.html#accc6d5863bfdcbf0dde4e412350729b1">Eexchani</a> += e/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>; <span class="comment">/* add to anisotropy+exchange energy */</span>
<a name="l00198"></a>00198 <span class="preprocessor">#ifdef EXCH</span>
<a name="l00199"></a>00199 <span class="preprocessor"></span>                                                                gdata-&gt;Eexchonly+= e/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>; <span class="comment">/* add to exchange only energy */</span>
<a name="l00200"></a>00200 <span class="preprocessor">#endif</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00202"></a>00202 <span class="preprocessor"></span><span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span><span class="comment">/* TODO: implement</span>
<a name="l00204"></a>00204 <span class="comment">  ierr = Hspintorq_Energy(gdata,M,&amp;e);  CHKERRQ(ierr);etot += e;</span>
<a name="l00205"></a>00205 <span class="comment">  ierr = Hspinforce_Energy(gdata,M,&amp;e); CHKERRQ(ierr);etot += e;</span>
<a name="l00206"></a>00206 <span class="comment">*/</span>
<a name="l00207"></a>00207 <span class="preprocessor">#endif</span>
<a name="l00208"></a>00208 <span class="preprocessor"></span>
<a name="l00209"></a>00209   gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>=etot/gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00212"></a>00212 }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
<a name="l00215"></a><a class="code" href="htot_8c.html#a09d3a5bbcb3e65c1e4c7e22818377b13">00215</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00216"></a>00216 {
<a name="l00217"></a>00217   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="comment">/* calculate &quot;magnetic moments&quot; VMom on vertices */</span>
<a name="l00220"></a>00220   ierr = VecPointwiseMult(VMom,gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   ierr = <a class="code" href="htot_8c.html#a8ad42d15c17241a1313243ebd0d0ab11">CalcEnergy</a>(VMom,gdata);CHKERRQ(ierr);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a><a class="code" href="htot_8c.html#a23837f4926a3a0dc211d349e16a9df87">00228</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a23837f4926a3a0dc211d349e16a9df87">Htot_EminiEnergy</a>(<a class="code" href="structGridData.html">GridData</a> *gdata, PetscReal *f)
<a name="l00229"></a>00229 {
<a name="l00230"></a>00230   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="preprocessor">#ifdef NO_VMS3</span>
<a name="l00233"></a>00233 <span class="preprocessor"></span>  <span class="comment">/* calculate &quot;pseudo&quot; energy for energy minmizer */</span>
<a name="l00234"></a>00234   ierr = <a class="code" href="htot_8c.html#a8ad42d15c17241a1313243ebd0d0ab11">CalcEnergy</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,gdata);CHKERRQ(ierr);
<a name="l00235"></a>00235   *f = gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>*gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>;
<a name="l00236"></a>00236 <span class="preprocessor">#endif</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>
<a name="l00238"></a>00238   <span class="comment">/* calculate real energy with &quot;magnetic moments&quot; VMom on vertices */</span>
<a name="l00239"></a>00239   ierr = VecPointwiseMult(VMom,gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00240"></a>00240   ierr = <a class="code" href="htot_8c.html#a8ad42d15c17241a1313243ebd0d0ab11">CalcEnergy</a>(VMom,gdata);CHKERRQ(ierr);
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 <span class="preprocessor">#ifndef NO_VMS3</span>
<a name="l00243"></a>00243 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00244"></a>00244 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>==53) {
<a name="l00245"></a>00245     *f = gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>*gdata-&gt;<a class="code" href="structGridData.html#a0ced0eaa5cb25c25363907973c7e69d6">totvol</a>;
<a name="l00246"></a>00246   }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;debug Etot=%g\n&quot;</span>,*f);
<a name="l00249"></a>00249 <span class="comment">/*</span>
<a name="l00250"></a>00250 <span class="comment">  gdata-&gt;inp=PetscAbs(gdata-&gt;inp);</span>
<a name="l00251"></a>00251 <span class="comment">  ierr = WriteLog(gdata);CHKERRQ(ierr);</span>
<a name="l00252"></a>00252 <span class="comment">  ierr = WriteSet(gdata);CHKERRQ(ierr);</span>
<a name="l00253"></a>00253 <span class="comment">*/</span>
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00256"></a>00256 }
<a name="l00257"></a>00257 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

